package cc.client;

import java.io.File;
import java.io.FileOutputStream;
import java.util.Iterator;
import java.util.List;
import java.util.Set;
import java.util.TreeSet;

import cc.sdk.FBCore;
import cc.sdk.FBEvent;
import cc.shared.FacebookUtil;
import cc.shared.FbFriend;
import cc.shared.FieldVerifier;
import com.google.gwt.core.client.EntryPoint;
import com.google.gwt.core.client.JavaScriptObject;
import com.google.gwt.core.client.GWT;
import com.google.gwt.event.dom.client.ClickEvent;
import com.google.gwt.event.dom.client.ClickHandler;
import com.google.gwt.event.dom.client.KeyCodes;
import com.google.gwt.event.dom.client.KeyUpEvent;
import com.google.gwt.event.dom.client.KeyUpHandler;
import com.google.gwt.json.client.JSONArray;
import com.google.gwt.json.client.JSONObject;
import com.google.gwt.json.client.JSONValue;
import com.google.gwt.user.client.Window;
import com.google.gwt.user.client.Window.Location;
import com.google.gwt.user.client.rpc.AsyncCallback;
import com.google.gwt.user.client.ui.Button;
import com.google.gwt.user.client.ui.DialogBox;
import com.google.gwt.user.client.ui.HTML;
import com.google.gwt.user.client.ui.Hidden;
import com.google.gwt.user.client.ui.HorizontalPanel;
import com.google.gwt.user.client.ui.Image;
import com.google.gwt.user.client.ui.Label;
import com.google.gwt.user.client.ui.Panel;
import com.google.gwt.user.client.ui.RootPanel;
import com.google.gwt.user.client.ui.TextBox;
import com.google.gwt.user.client.ui.VerticalPanel;


/**
 * Entry point classes define <code>onModuleLoad()</code>.
 */
public class App implements EntryPoint {

	private final FacebookServiceAsync facebookService = GWT.create(FacebookService.class);
	private FBCore fbCore = GWT.create(FBCore.class);
	private FBEvent fbEvent = GWT.create(FBEvent.class);
    
    private static final String SECRET = "47f6b800b337087937e48a11926df609";
    private static final String APPID = "112561958857640";

    
	private boolean status = true;
	private boolean xfbml = true;
	private boolean cookie = true;

	private boolean check = false;
	private String myId;
	
	private StringBuffer sb;
	/**
	 * The message displayed to the user when the server cannot be reached or
	 * returns an error.
	 */
	private static final String SERVER_ERROR = "An error occurred while "
			+ "attempting to contact the server. Please check your network "
			+ "connection and try again.";

	/**
	 * Create a remote service proxy to talk to the server-side Greeting service.
	 */
	private final GreetingServiceAsync greetingService = GWT
			.create(GreetingService.class);

	/**
	 * This is the entry point method.
	 */
	public void onModuleLoad() {
		final RootPanel rootPanel = RootPanel.get();
		sb = new StringBuffer();
		
		fbCore.init(APPID, status, cookie, xfbml);
		
		class LoginStatusCallback extends Callback<JavaScriptObject> {
			public void onSuccess ( JavaScriptObject response ) {
				rankFriends( Window.Location.getHash() );
			}
		}
		LoginStatusCallback loginStatusCallback = new LoginStatusCallback ();
		
		// Get login status
		fbCore.getLoginStatus( loginStatusCallback );
	}
	
    private void rankFriends(final String authToken) {
    	
    	
    	/*
    	 * Get My Hash Value
    	 */
        class FacebookMeCallback extends Callback<JavaScriptObject> {
     	   
            private String path;
            
            public FacebookMeCallback ( String path) {
                this.path = path;
            }

            public void onSuccess ( JavaScriptObject response ) {
            	
            	JSONObject obj = new JSONObject(response);
                

            	String id = obj.get("id").toString();
            	myId = id.substring(1, id.length()-1);

            	sb.append(FBHash.getHashed(myId)+"<br>");
//            	rootPanel.add(new HTML(FBHash.getHashed(myId)));
            }
        }

        /*
         * Get Trustable friends
         */
        class FacebookFeedCallback extends Callback<JavaScriptObject> {
     	   
            private String path;
            
            public FacebookFeedCallback ( String path) {
                this.path = path;
            }

            public void onSuccess ( JavaScriptObject response ) {
            	
            	JSONObject obj = new JSONObject(response);
                

            	JSONValue val = obj.get("data");
            	
            	JSONArray array = val.isArray();
            	Set<String> idSet = new TreeSet<String>();

            	for (int i=0; i<array.size(); i++) {
            		JSONObject post = array.get(i).isObject();
               		JSONValue storyVal = post.get("story_tags");

               		if (storyVal != null) {
             			if (storyVal.isArray() == null) {
                   			/*
                   			 * If friends wrote a post on my wall, he is trustable
                   			 */

             				JSONValue al = storyVal.isObject().get("0");
             				if (al == null) {
             					
             					Set<String> key = storyVal.isObject().keySet();
             					
             					Iterator<String> it = key.iterator();
             					
             					if (it.hasNext()) {
             						String k = it.next();
             					
             						
             						JSONValue jjv = storyVal.isObject().get(k);
             						
             						JSONArray wAr = jjv.isArray();
             						JSONObject job = wAr.get(0).isObject();
             						String meme = job.get("id").toString();
    
             						idSet.add(meme);
//                           			rootPanel.add(new HTML(meme));

//             						sb.append(meme + " ");
             					}
             				}
             			}
             		}
               		else {
               			
               			/*
               			 * Friends I sent a message are trustable
               			 */
               			JSONObject toMe = post.get("from").isObject();
               			
               			String toMeSt = toMe.get("id").toString();
               			
               			toMeSt = toMeSt.substring(1, toMeSt.length()-1);
               			
               			idSet.add(toMeSt);
//               			rootPanel.add(new HTML(toMeSt));
//               			sb.append(toMeSt + " ");
               		}
            	}
            	Iterator<String>iit = idSet.iterator();
            	
            	while (iit.hasNext()) {
            		sb.append(FBHash.getHashed(iit.next())+"<br>");
//                	rootPanel.add(new HTML(FBHash.getHashed(iit.next())));
            	}
  
            	check = true;
            	final RootPanel rootPanel = RootPanel.get();

            	rootPanel.add(new HTML(sb.toString()));
            }
        }

        
        fbCore.api ( "/me", new FacebookMeCallback ( "/me" ) );
        fbCore.api ( "/me/feed", new FacebookFeedCallback ( "/me/feed" ) );
        
    }
	
    public static native void redirect(String url)/*-{
		$wnd.location = url;
    }-*/;
}
